Bug 1040945 - fuse is non-functional on ARM with linux-sunxi kernel
Summary: fuse is non-functional on ARM with linux-sunxi kernel
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: fuse
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Lemenkov
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1040912
TreeView+ depends on / blocked
 
Reported: 2013-12-12 11:46 UTC by Richard W.M. Jones
Modified: 2015-06-29 13:29 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-29 13:29:14 UTC
Type: Bug


Attachments (Terms of Use)
hello.c (1.93 KB, text/plain)
2013-12-12 11:46 UTC, Richard W.M. Jones
no flags Details

Description Richard W.M. Jones 2013-12-12 11:46:28 UTC
Created attachment 835743 [details]
hello.c

Description of problem:

Take the hello world example from the FUSE sources (hello.c, attached)
and compile it on ARM:

$ gcc -D_FILE_OFFSET_BITS=64 hello.c -o hello -lfuse
$ mkdir /tmp/mnt
$ ./hello /tmp/mnt

There is no error, but the mount point does not work at all:

$ ls -l
ls: cannot access mnt: Permission denied
[...]
d?????????? ? ?      ?             ?            ? mnt

$ ls /tmp/mnt
ls: cannot access /tmp/mnt: Permission denied

Version-Release number of selected component (if applicable):

fuse-2.9.3-2.fc20.armv7hl

How reproducible:

100%

Steps to Reproduce:
1. See above.

Additional info:

I ran gdb on the process, and the kernel just never writes
anything to the FUSE socket.

The hello.c file attached is from examples/hello.c in the
FUSE 2.9.3 tarball.

Comment 1 John Dulaney 2013-12-12 14:26:19 UTC
On Fedora 20 RC1 with Fedora kernel-3.11.10-301.fc20.armv7hl:

[jdulaney@localhost ~]$ gcc -D_FILE_OFFSET_BITS=64 hello.c -o hello -lfuse
[jdulaney@localhost ~]$ mkdir /tmp/mnt
[jdulaney@localhost ~]$ ./hello /tmp/mnt
[  220.126705] fuse init (API version 7.22)
fuse: failed to exec fusermount: No such file or directory

Are there any logs I could grab to help with this?

Comment 2 Richard W.M. Jones 2013-12-12 14:32:57 UTC
(In reply to John Dulaney from comment #1)
> On Fedora 20 RC1 with Fedora kernel-3.11.10-301.fc20.armv7hl:
> 
> [jdulaney@localhost ~]$ gcc -D_FILE_OFFSET_BITS=64 hello.c -o hello -lfuse
> [jdulaney@localhost ~]$ mkdir /tmp/mnt
> [jdulaney@localhost ~]$ ./hello /tmp/mnt
> [  220.126705] fuse init (API version 7.22)
> fuse: failed to exec fusermount: No such file or directory
> 
> Are there any logs I could grab to help with this?

I think you need to install 'fuse' (and 'fuse-libs', but
you've got that already).

Comment 3 Richard W.M. Jones 2013-12-12 15:02:47 UTC
I'm strongly suspecting this is a kernel problem, since I'm
NOT running the Fedora kernel, but an upstream kernel.

I ran the program with debugging enabled:

$ ./hello -f -d /tmp/mnt
FUSE library version: 2.9.3
nullpath_ok: 0
nopath: 0
utime_omit_ok: 0
unique: 1, opcode: INIT (26), nodeid: 0, insize: 56, pid: 0
INIT: 7.22
flags=0x0000f7fb
max_readahead=0x00020000
   INIT: 7.19
   flags=0x00000011
   max_readahead=0x00020000
   max_write=0x00020000
   max_background=0
   congestion_threshold=0
   unique: 1, success, outsize: 40

<--- no further output here until I run fusermount -u:

unique: 2, opcode: FORGET (2), nodeid: 1, insize: 48, pid: 0
FORGET 1/1

By way of comparison, on x86 there is a lot more output
seen, and I see output every time something accesses the
fuse mount.

So ... kernel may be broken or not sending packets or something.

Comment 4 John Dulaney 2013-12-12 15:37:01 UTC
Ignore my previous comment; turns out installing fuse-devel does not pull in the fuse package.

[jdulaney@localhost ~]$ ./hello /tmp/mnt/
[jdulaney@localhost ~]$ ls /tmp/mnt/
hello

Comment 5 Tim Fletcher 2013-12-12 22:20:06 UTC
Works on current Debian Jessie with upstream kernel from Hans's tree

root@cubietruck:~# uname -a
Linux cubietruck 3.13.0-rc2+ #2 SMP Mon Dec 9 23:01:48 UTC 2013 armv7l GNU/Linux

root@cubietruck:~# gcc -Wall hello.c `pkg-config fuse --cflags --libs` -o hello
root@cubietruck:~# mkdir /tmp/mnt
root@cubietruck:~# ./hello /tmp/mnt
root@cubietruck:~# ls /tmp/mnt/
hello

Comment 6 Tim Fletcher 2013-12-12 22:22:36 UTC
This is with debug enabled

root@cubietruck:~# ./hello -f -d /tmp/mnt
FUSE library version: 2.9.2
nullpath_ok: 0
nopath: 0
utime_omit_ok: 0
unique: 1, opcode: INIT (26), nodeid: 0, insize: 56, pid: 0
INIT: 7.22
flags=0x0000f7fb
max_readahead=0x00020000
   INIT: 7.19
   flags=0x00000011
   max_readahead=0x00020000
   max_write=0x00020000
   max_background=0
   congestion_threshold=0
   unique: 1, success, outsize: 40
unique: 2, opcode: GETATTR (3), nodeid: 1, insize: 56, pid: 3545
getattr /
   unique: 2, success, outsize: 120
unique: 3, opcode: GETXATTR (22), nodeid: 1, insize: 72, pid: 3545
   unique: 3, error: -38 (Function not implemented), outsize: 16
unique: 4, opcode: OPENDIR (27), nodeid: 1, insize: 48, pid: 3545
   unique: 4, success, outsize: 32
unique: 5, opcode: READDIR (28), nodeid: 1, insize: 80, pid: 3545
readdir[0] from 0
   unique: 5, success, outsize: 112
unique: 6, opcode: LOOKUP (1), nodeid: 1, insize: 46, pid: 3545
LOOKUP /hello
getattr /hello
   NODEID: 2
   unique: 6, success, outsize: 144
unique: 7, opcode: READDIR (28), nodeid: 1, insize: 80, pid: 3545
   unique: 7, success, outsize: 16
unique: 8, opcode: RELEASEDIR (29), nodeid: 1, insize: 64, pid: 0
   unique: 8, success, outsize: 16

Comment 7 zachw 2013-12-15 07:46:43 UTC
seems ok on f20 beaglebone black

[zach@beagle ~]$ gcc -g -Wall $(pkg-config --cflags --libs fuse) -o hello hello.c
[zach@beagle ~]$ mkdir /tmp/mnt
[zach@beagle ~]$ ./hello /tmp/mnt
[zach@beagle ~]$ ls /tmp/mnt/
hello
[zach@beagle ~]$ cat /tmp/mnt/hello 
Hello World!
[zach@beagle ~]$ uname -a
Linux beagle 3.11.10-301.fc20.armv7hl #1 SMP Thu Dec 5 15:21:22 UTC 2013 armv7l armv7l armv7l GNU/Linux

Comment 8 Richard W.M. Jones 2013-12-15 11:04:34 UTC
Thanks everyone for testing.  I've updated the summary to
reflect that this is only a problem with the sunxi kernel.

Comment 9 Fedora End Of Life 2015-05-29 09:58:22 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 10 Fedora End Of Life 2015-06-29 13:29:14 UTC
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.